<template>
  <v-layout row justify-center>
   <v-navigation-drawer
      width="580"
      v-model="invoicemodal"
      fixed
      right
      clippe
    >
    <v-btn flat small class="green-darken-text font-roboto" @click="invoicemodal = false">
      <v-icon>close</v-icon>CLOSE
    </v-btn>
      <!-- <v-btn flat  icon @click="invoicemodal = false" class="green--text" dense>
        &nbsp;&nbsp;&nbsp;&nbsp;<v-icon>close</v-icon>
        close
      </v-btn> -->
      <v-spacer></v-spacer>

        <v-flex xs12>
          <p align="center" class="font-size-20-bold font-roboto">Invoice No : {{currentinvoiceno}}</p>
        </v-flex>
        <v-layout>
          <v-flex xs6 py-2 px-2 >
            <p class="font-size-14 font-roboto" align="right">
              Tax ID &nbsp;&nbsp;
              <br />
              Invoice No &nbsp;&nbsp;
              <br />
              Invoice Date&nbsp;&nbsp;
            </p>
          </v-flex>
          <v-flex xs6 py-2>
            <p class="font-size-14-bold font-roboto" align="left" >
              <strong>{{ taxid }}</strong>
              <br />
              <strong>{{invoicedatail.Invoice_no}}</strong>
              <br />
              <strong>{{ invoicedatail.Document_date }}</strong>
            </p>
          </v-flex>
        </v-layout>
        <v-layout align-center justify-center row wrap>
          <v-flex xs11 py-1>
            <v-data-table
              :headers="tablelistheaders"
              :items="itemlistview"
              hide-actions
              class="elevation-1 font-roboto"
            >
              <template v-slot:items="props" >
                <tr >
                  <td class="text-xs-center">{{ props.index + 1}}</td>
                  <td class="text-xs-left">{{ props.item.Item_description }}</td>
                  <td class="text-xs-right">{{ props.item.Item_AmountExcVat }}</td>
                  <td class="text-xs-center">{{ props.item.Quantity }}</td>
                  <td class="text-xs-right">{{ props.item.Item_TotalPrice }}</td>
                </tr>
              </template>
            </v-data-table>
          </v-flex>
          <v-layout align-center justify-end row wrap px-4>
            <v-flex xs10 py-3 px-4>
              <p class="font-size-14 font-roboto" align="right">
                Subtotal (THB) &nbsp;&nbsp;
                <br />
                VAT (THB) &nbsp;&nbsp;
                <br />
                <strong >Total (THB) &nbsp;&nbsp;</strong>
              </p>
            </v-flex>
            <v-flex xs2 py-4>
              <p class="font-size-14 font-roboto" align="right">
                {{ this.addCommas(parseFloat(invoicedatail.Invoice_Amount).toFixed(2)) }}
                <br />
                {{ this.addCommas(parseFloat(invoicedatail.Vat_amount).toFixed(2)) }}
                <br />
                <strong>{{ this.addCommas(parseFloat(invoicedatail.InvoiceamountWithVat).toFixed(2)) }}</strong>
              </p>
            </v-flex>
          </v-layout>
        </v-layout>
        <v-flex pb-3></v-flex>
    </v-navigation-drawer>
    <form ref="paymentform" name="PostForm" method="POST" :action="paymenturl">
      <input name="access_token" type="hidden" :value="paymenttoken" />
    </form>
  </v-layout>
</template>

<script>
import { sync } from 'vuex-pathify'
import moment from 'moment'
moment.locale('en')
export default {
  data () {
    return {
      taxid: this.$cookies.get('taxid'),
      dialogloader: true,
      notifications: false,
      sound: true,
      widgets: false,
      invoicedatail: { item_list: [] },
      tablelistheaders: [
        { text: 'No.', value: 'index', sortable: false, align: 'center' },
        {
          text: 'Description',
          value: 'Item_description',
          sortable: false,
          align: 'center'

        },
        {
          text: 'Unit Amount',
          value: 'Item_AmountExcVat',
          sortable: false,
          align: 'center'
        },
        { text: 'Quantity', value: 'Quantity', sortable: false, align: 'center' },
        {
          text: 'Amount',
          value: 'Item_AmountExcVat',
          sortable: false,
          align: 'center'
        }
      ],
      paymenttoken: ''
    }
  },
  methods: {
    async getinvoicedetails () {
      try {
        if (this.currentinvoiceno) {
          this.dialogloader = true
          let { data } = await this.axios.get(
            // 'http://203.150.108.180:3000/api/v1/invoice_data/' + this.currentinvoiceno
            `${process.env.VUE_APP_APIHOST}/invdetail_from_db/`+ this.currentinvoiceno
          )
          data.Document_date = moment(data.Document_date).format('D MMMM YYYY')
          this.invoicedatail = data
          this.dialogloader = false
          // console.log('invoicedetail',this.invoicedatail);
        }
      } catch (error) {
        // this.istableloading = false
        // alert(error.message)
        console.log(error.message)
      }
    },
    addCommas (nStr) {
      nStr += ''
      var x = nStr.split('.')
      var x1 = x[0]
      var x2 = x.length > 1 ? '.' + x[1] : ''
      var rgx = /(\d+)(\d{3})/
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2')
      }
      return x1 + x2
    }
  },
  computed: {
    invoicemodal: sync('invoicemodal'),
    currentinvoiceno: sync('currentinvoiceno'),
    typeofcompany: sync('typeofcompany'),
    itemlistview () {
      return this.invoicedatail.item_list.map(item => {
        return {
          ...item,
          Item_TotalPrice:
            this.addCommas((item.Quantity*item.Item_AmountExcVat).toFixed(2)) + ' THB',
          Item_AmountExcVat:
            this.addCommas(item.Item_AmountExcVat.toFixed(2)) + ' THB',
          // Item_AmountIncVat:
          //   this.addCommas(item.Item_AmountIncVat.toFixed(2)) + ' THB'
        }
      })
    },
    detailview () {
      return Object.keys(this.invoicedatail)
        .filter(
          key =>
            ![
              'SO_Number',
              'Invoice_no',
              'invoice_description',
              'item_list'
            ].includes(key)
        )
        .reduce((obj, key) => {
          obj[key] = this.invoicedatail[key]
          return obj
        }, {})
    },
    paymenturl () {
      return process.env.VUE_APP_PAYMENTURL
    }
  },
  created () {
    this.dialogloader = false
    this.getinvoicedetails()
  },
  watch: {
    currentinvoiceno () {
      this.getinvoicedetails()
    }
  }
}
</script>

<style>
</style>
